﻿using Bulldozer.Entities;

namespace Bulldozer.DrawingObjects
{
    public static class ExtentionDrawingBulldozer
    {
        public static DrawingBulldozer? CreateDrawingBulldozer(this string info, char separatorForObject, int width, int height)
        {
            string[] strs = info.Split(separatorForObject);
            if (strs.Length == 4)
            {
                return new DrawingBulldozer(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]), Color.FromName(strs[3]), width, height);
            }
            if (strs.Length == 7)
            {
                return new DrawingBulldozerUpgraded(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]),
                Color.FromName(strs[2]),
                Color.FromName(strs[3]),
                Color.FromName(strs[4]),
                Convert.ToBoolean(strs[5]),
                Convert.ToBoolean(strs[6]), width, height);
            }
            return null;
        }
        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawingBulldozer">Сохраняемый объект</param>
        /// <param name="separatorForObject">Разделитель даннных</param>
        /// <returns>Строка с данными по объекту</returns>
        public static string GetDataForSave(this DrawingBulldozer drawingBulldozer, char separatorForObject)
        {
            var bulldozer = drawingBulldozer.EntityBulldozer;
            if (bulldozer == null)
            {
                return string.Empty;
            }
            var str = $"{bulldozer.Speed}{separatorForObject}{bulldozer.Weight}{separatorForObject}{bulldozer.BodyColor.Name}{separatorForObject}{bulldozer.AdditionalColor.Name}";
            if (bulldozer is not EntityBulldozerUpgraded bulldozerUpgraded)
            {
                return str;
            }
            return $"{str}{separatorForObject}{bulldozerUpgraded.DopColor.Name}{separatorForObject}{bulldozerUpgraded.Ripper}{separatorForObject}{bulldozerUpgraded.Blade}";
        }
    }
}
